
<script>
import { required, requiredIf, url } from "vuelidate/lib/validators";
import config from "../../config";
import { error_message } from "../../Helper/helper";
import { success_message } from "../../Helper/helper";
import { pageService } from "../../services";
import tinymce from "vue-tinymce-editor";

export default {
  components: { config, pageService, tinymce },
  data() {
    return {
      config: config,
      typeform: {
        page_name: "",
        page_content: "",
        content_type: "1",
        content_link: "",
        identifier: "3"
      },
      existing_message: "",
      content_options: [
        {
          text: this.trans.get("__JSON__.Content"),
          value: 1,
        },
        {
          text: this.trans.get("__JSON__.Link"),
          value: 0,
        }
      ],
      display_in: { customer: "1", partner: "1", driver: "1" },
      plugins: [
        // "advlist autolink link image lists charmap print preview hr anchor pagebreak spellchecker",
        "searchreplace wordcount visualblocks visualchars code fullscreen insertdatetime media nonbreaking",
        "save table contextmenu directionality emoticons template paste textcolor",
      ],
      toolbar:
        "insertfile undo redo | styleselect | bold italic | alignleft aligncenter alignright alignjustify | bullist numlist outdent indent | l      ink image | print preview media fullpage | forecolor backcolor emoticons",
      options: {
        height: 300,
        style_formats: [
          { title: "Bold text", inline: "b" },
          { title: "Red text", inline: "span", styles: { color: "#ff0000" } },
          { title: "Red header", block: "h1", styles: { color: "#ff0000" } },
          { title: "Example 1", inline: "span", classes: "example1" },
          { title: "Example 2", inline: "span", classes: "example2" },
          { title: "Table styles" },
          { title: "Table row 1", selector: "tr", classes: "tablerow1" },
        ],
      },
    };
  },
  validations: {
    typeform: {
      page_name: {
        required,
      },
      page_content: {
        required: requiredIf(function (form) {
          return this.typeform.content_type == 1;
        }),
      },
      content_link: {
        required: requiredIf(function (form) {
          return this.typeform.content_type == 0;
        }),
        url
      }
    },
  },
  methods: {
    onCategoryChange(event) {
      if (event.target.value == 1 || event.target.value == 2) {
        this.existing_message = "If you change category as Privacy policy or Terms & Conditions Page then it will overwrite existing pages to Other category";
      }
    },

    addPage() {
      this.$v.$touch();
      if (this.$v.typeform.$invalid) {
        return;
      } else {
        pageService.addContentPage({
            ...this.typeform,
            display_in: JSON.stringify(this.display_in),
          }).then((response) => {
            if (response.data.code === 200) {
              success_message(response.data.message);
              this.$router.push({ name: "content-page" });              
            } else {
              error_message(response.data.message);
            }
          });
      }
    },
  },
};
</script>

<template>
  <form @submit.prevent="addPage">
    <div class="card">
      <div class="card-body">
        <p class="card-title-desc"></p>
        <div class="row">
          <div class="col-sm-6">
            <div class="form-group">
              <label class="required">{{trans.trans("__JSON__.Page Name")}}</label>
              <input id="page_name" v-model="$v.typeform.page_name.$model" type="text" class="form-control" :placeholder="trans.trans('__JSON__.Page Name')" name="page_name"
                :class="{ 'is-invalid': $v.typeform.page_name.$error }" />
              <div v-if="$v.typeform.page_name.$error" class="invalid-feedback">
                <span v-if="!$v.typeform.page_name.required">{{
                  trans.get("__JSON__.Please Enter Page Name")
                }}</span>
              </div>
            </div>
          </div>
          <div class="col-sm-6">
            <div class="form-group mb-0">
              <label>{{ trans.get("__JSON__.Display In") }}</label>
            </div>
            <div class="row vendor-status platform-type mb-0">
              <b-form-group>
                <label class="switch">
                  <input type="checkbox" id="customer" name="customer" v-model="display_in.customer" class="switch-on"
                    true-value="1" false-value="0" />
                  <div class="slider round">
                    <span class="on">{{
                      trans.get("__JSON__.Customer")
                    }}</span>
                    <span class="off">{{
                      trans.get("__JSON__.Customer")
                    }}</span>
                  </div>
                </label>
              </b-form-group>
              <b-form-group class="partner">
                <label class="switch">
                  <input type="checkbox" id="partner" name="partner" v-model="display_in.partner" class="switch-on"
                    true-value="1" false-value="0" />
                  <div class="slider round">
                    <span class="on">{{
                      trans.get("__JSON__.Partner")
                    }}</span>
                    <span class="off">{{
                      trans.get("__JSON__.Partner")
                    }}</span>
                  </div>
                </label>
              </b-form-group>
              <b-form-group class="driver">
                <label class="switch">
                  <input type="checkbox" id="driver" name="driver" v-model="display_in.driver" class="switch-on"
                    true-value="1" false-value="0" />
                  <div class="slider round">
                    <span class="on">{{
                      trans.get("__JSON__.Drivers")
                    }}</span>
                    <span class="off">{{
                      trans.get("__JSON__.Drivers")
                    }}</span>
                  </div>
                </label>
              </b-form-group>
            </div>
          </div>
        </div>
        <div class="row">
          <div class="col-sm-2 vendor-status content-type">
            <b-form-group id="input-group-1" :label="trans.get('__JSON__.Content Type')" label-for="content_type">
              <b-form-radio-group id="btn-radios-1" class="check-group" v-model="typeform.content_type"
                :options="content_options" buttons name="radios-btn-default"></b-form-radio-group>
            </b-form-group>
          </div>
          <div class="col-sm-4" v-if="typeform.content_type == '0'">
            <label class="required">{{trans.trans("__JSON__.Content Link")}}</label>
            <input id="content_link" v-model="$v.typeform.content_link.$model" type="url" class="form-control" :placeholder="trans.get('__JSON__.https://')" name="content_link" :class="{ 'is-invalid': $v.typeform.content_link.$error }" />
            <div v-if="$v.typeform.content_link.$error" class="invalid-feedback">
              <span v-if="!$v.typeform.content_link.required">{{trans.get("__JSON__.Please Enter Content Link")}}</span>
              <span v-if="!$v.typeform.content_link.url">{{ trans.get('__JSON__.This value should be a valid url')}}.</span>
            </div>
          </div>
          <div class="col-sm-2">
            <div class="form-group">
              <label class="control-label">{{ trans.trans('__JSON__.Category') }}</label>
              <select class="custom-select" v-model="typeform.identifier" id="identifier" name="identifier" @change="onCategoryChange($event)">
                <option value="1">{{ trans.get('__JSON__.Terms & Condition') }}</option>
                <option value="2">{{ trans.get('__JSON__.Privacy Policy') }}</option>
                <option value="3" selected>{{ trans.get('__JSON__.Other') }}</option>
              </select>
            </div>
          </div>
          <div class="col-sm-6" v-if="typeform.identifier == 1 || typeform.identifier == 2">
            <span class="text-danger">*{{ existing_message }}</span>
          </div>
        </div>
        <div class="row">
          <div class="col-sm-12" v-if="typeform.content_type == '1'">
            <div class="form-group">
              <label class="required">{{trans.trans("__JSON__.Page Content")}}</label>
              <tinymce id="d1" v-model="$v.typeform.page_content.$model" :plugins="plugins" :toolbar="toolbar" :other_options="options" :class="{ 'is-invalid': $v.typeform.page_content.$error }">
              </tinymce>
              <div v-if="$v.typeform.page_content.$error" class="invalid-feedback">
                <span v-if="!$v.typeform.page_content.required">{{trans.get("__JSON__.Please Enter Page Content")}}</span>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="row">
      <div class="col-sm-6">
        <button class="btn btn-primary mr-1 mt-3">{{ trans.get("__JSON__.Add Content Page") }}</button>
        <router-link variant="secondary" class="btn btn-secondary mt-3" :to="{ name: 'content-page' }">{{trans.get("__JSON__.Cancel") }}</router-link>
      </div>
    </div>
  </form>
</template>
<style scoped>
.content-type .switch {
  width: 80px;
}

.content-type input.switch-on:checked+.slider:before {
  left: 27px;
}

.platform-type {
  padding-left: 12px;
}

.platform-type .switch {
  width: 96px;
  height: 36px;
}

.platform-type .partner {
  padding-left: 20px;
}

.platform-type .driver {
  padding-left: 20px;
}

.platform-type input.switch-on:checked+.slider:before {
  left: 40px;
}

.platform-type .switch .off {
  left: 58%;
}
</style>